# /home/coin/svn-release/Alps-1.4.6/CoinUtils/src/CoinSort.hpp File Reference

`#include <functional>`
`#include <new>`
`#include <algorithm>`
`#include "CoinDistance.hpp"`
Include dependency graph for CoinSort.hpp:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
struct | CoinPair< S, T >
| An ordered pair. More...
class | CoinFirstLess_2< S, T >
| Function operator. More...
class | CoinFirstGreater_2< S, T >
| Function operator. More...
class | CoinFirstAbsLess_2< S, T >
| Function operator. More...
class | CoinFirstAbsGreater_2< S, T >
| Function operator. More...
class | CoinExternalVectorFirstLess_2< S, T, V >
| Function operator. More...
class | CoinExternalVectorFirstGreater_2< S, T, V >
| Function operator. More...
class | CoinTriple< S, T, U >
class | CoinFirstLess_3< S, T, U >
| Function operator. More...
class | CoinFirstGreater_3< S, T, U >
| Function operator. More...
class | CoinFirstAbsLess_3< S, T, U >
| Function operator. More...
class | CoinFirstAbsGreater_3< S, T, U >
| Function operator. More...
class | CoinExternalVectorFirstLess_3< S, T, U, V >
| Function operator. More...
class | CoinExternalVectorFirstGreater_3< S, T, U, V >
| Function operator. More...
## Typedefs
Typedefs for sorting the entries of a packed vector based on an
external vector.
typedef CoinExternalVectorFirstLess_3 < int, int, double, double > | CoinIncrSolutionOrdered
| Sort packed vector in increasing order of the external vector.
typedef CoinExternalVectorFirstGreater_3 < int, int, double, double > | CoinDecrSolutionOrdered
| Sort packed vector in decreasing order of the external vector.
## Functions
template<class S , class T , class CoinCompare2 >
void | CoinSort_2 (S *sfirst, S *slast, T *tfirst, const CoinCompare2 &pc)
| Sort a pair of containers.
template<class S , class T >
void | CoinSort_2Std (S *sfirst, S *slast, T *tfirst)
template<class S , class T >
void | CoinSort_2 (S *sfirst, S *slast, T *tfirst)
template<class S , class T >
void | CoinShortSort_2 (S *key, S *lastKey, T *array2)
| Sort without new and delete.
template<class S , class T , class U , class CoinCompare3 >
void | CoinSort_3 (S *sfirst, S *slast, T *tfirst, U *ufirst, const CoinCompare3 &tc)
| Sort a triple of containers.
template<class S , class T , class U >
void | CoinSort_3 (S *sfirst, S *slast, T *tfirst, U *ufirst)

## Typedef Documentation

typedef CoinExternalVectorFirstLess_3<int, int, double, double> CoinIncrSolutionOrdered

Sort packed vector in increasing order of the external vector.

Definition at line 571 of file CoinSort.hpp.

typedef CoinExternalVectorFirstGreater_3<int, int, double, double> CoinDecrSolutionOrdered

Sort packed vector in decreasing order of the external vector.

Definition at line 574 of file CoinSort.hpp.

## Function Documentation

template<class S , class T , class CoinCompare2 >

void CoinSort_2 | ( | S * | sfirst,
|  | S * | slast,
|  | T * | tfirst,
|  | const CoinCompare2 & | pc |
| ) |  |  | `[inline]`

Sort a pair of containers.

Iter_S - iterator for first container
Iter_T - iterator for 2nd container
CoinCompare2 - class comparing CoinPairs

Definition at line 188 of file CoinSort.hpp.

template<class S , class T >

void CoinSort_2Std | ( | S * | sfirst,
|  | S * | slast,
|  | T * | tfirst |
| ) |  |  | `[inline]`

Definition at line 222 of file CoinSort.hpp.

template<class S , class T >

void CoinSort_2 | ( | S * | sfirst,
|  | S * | slast,
|  | T * | tfirst |
| ) |  |  | `[inline]`

Definition at line 229 of file CoinSort.hpp.

template<class S , class T >

void CoinShortSort_2 | ( | S * | key,
|  | S * | lastKey,
|  | T * | array2 |
| ) |  |  | `[inline]`

Sort without new and delete.

Definition at line 357 of file CoinSort.hpp.

template<class S , class T , class U , class CoinCompare3 >

void CoinSort_3 | ( | S * | sfirst,
|  | S * | slast,
|  | T * | tfirst,
|  | U * | ufirst,
|  | const CoinCompare3 & | tc |
| ) |  |  | `[inline]`

Sort a triple of containers.

Iter_S - iterator for first container
Iter_T - iterator for 2nd container
Iter_U - iterator for 3rd container
CoinCompare3 - class comparing CoinTriples

Definition at line 636 of file CoinSort.hpp.

template<class S , class T , class U >

void CoinSort_3 | ( | S * | sfirst,
|  | S * | slast,
|  | T * | tfirst,
|  | U * | ufirst |
| ) |  |  | `[inline]`

Definition at line 669 of file CoinSort.hpp.